import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;

public class TestClient {

	
	
	
	public static void main(String[] args) throws IOException {
		String ip  = "localhost";
		//String ip  = "localhost";
	    int port =7061;
		
		//int port =1607;
   
	    SocketAddress socketAddress =  new InetSocketAddress(ip,port);
	    Socket socket = new Socket();
	    socket.connect(socketAddress);
	    
	    String line = null;
	    
	    BufferedReader keyRead =  new BufferedReader(new InputStreamReader(System.in));
	    
	    OutputStream ostream = socket.getOutputStream();
	    PrintWriter pwrite = new PrintWriter(ostream,true);
	    
	    InputStream istream = socket.getInputStream();
	    BufferedReader receivedRead =  new BufferedReader(new InputStreamReader(istream));
	    String input=null;
	    do {
	    	
	    	System.out.println("1.  getCountry");
	    	System.out.println("2.  getBooks");
	    	System.out.println("3.  getCustomer");
	    	System.out.println("4.  getOrder");
	    	System.out.println("5.  getLetter");
	    	System.out.println("6.  STOP RECORDING");
	    	System.out.println("Enter your input");
	    	input = keyRead.readLine();
	    	
	    	switch(input) {
	    	 
	    	case "1":
	    		System.out.println("Request=" + getCountry()); 
	    		pwrite.println("Content-length: 280\nContent-type: application/xml\nnrfTransactionId: 15523212610091\n\n" + getCountry()  );
	    		//pwrite.println("Content-type: application/xml");
	    	//	pwrite.println("nrfTransactionId: 15523212610091");
	    	//	pwrite.println("");
	    		//pwrite.println(getCountry());             
	            //pwrite.flush();
	            readBufferedReader(receivedRead);
	    		
	    		break;
	    	case "2":
	    		System.out.println("Request=" + getBooks());
	    		pwrite.println("Content-length: 280\nContent-type: application/xml\nnrfTransactionId: 15523280765362\n\n" + getBooks()  );
	    		/*
	    		pwrite.println("Content-length: 280");
	    		pwrite.println("Content-type: application/xml");
	    		pwrite.println("nrfTransactionId: 15523280765362");
	    		pwrite.println("");
	    		pwrite.println(getBooks());       */      
	            //pwrite.flush();
	            readBufferedReader(receivedRead);
	    		
	    		break;
	    	case "3":
	    		System.out.println("Request=" + getCustomer()); 
	    		pwrite.println("Content-length: 280\nContent-type: application/xml\nnrfTransactionId: 15523212749834\n\n" + getCustomer()  );
	    		
	    		/*
	    		pwrite.println("Content-length: 280");
	    		pwrite.println("Content-type: application/xml");
	    		pwrite.println("nrfTransactionId: 15523212749834");
	    		pwrite.println("");
	    		pwrite.println(getCustomer());    */         
	           // pwrite.flush();
	            readBufferedReader(receivedRead);
	    		
	    		break;
	    	case "4":
	    		System.out.println("Request=" + getOrder());
	    		pwrite.println("Content-length: 280\nContent-type: application/xml\nnrfTransactionId: 15523279069925\n\n" + getOrder()  );
	    		/*
	    		pwrite.println("Content-length: 280");
	    		pwrite.println("Content-type: application/xml");
	    		pwrite.println("nrfTransactionId: 15523279069925");
	    		pwrite.println("");
	    		pwrite.println(getOrder());   */          
	           // pwrite.flush();
	            readBufferedReader(receivedRead);
	    		
	    		break;
	    	case "5":
	    		
	    		pwrite.println(getLetter());             
	            //pwrite.flush();
	            readBufferedReader(receivedRead);
	    		
	    		break;
	    	case "6":
	    		socket.close();
	    		System.exit(0);
	    		break;
	    		
	    		default : System.out.println("You have entered wrong input");
	    	
	    	}
	    	
	    	
	    }while(true);
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    
	    //if (socket !=null && )
		
	}
	
	
	
	public static String getCountry() {
		
		System.out.println("getCountry getting called");
		return "<?xml version=\"1.0\"?>"
				+ "<nrf:NRFTransaction version=\"07.01.0001\" "
				+ "RequestMethodName=\"raveGetIsDutiable\" RequestMethodResponseName=\"raveGetIsDutiableResponse\" "
				+ "transactionID=\"15523212610091\" xmlns:nrf=\"http://ups.com/nrfServerInterface\">"
				+ "<nrf:Request><nrf:raveGetIsDutiable origCountry=\"US\" origPostalCode=\"07652\" origCity=\"\" destCountry=\"US\""
				+ " destPostalCode=\"90210\" destCity=\"\"/></nrf:Request></nrf:NRFTransaction>";
	}

	public static String getBooks() {
		
		System.out.println("getBooks getting called");
		
		return "<?xml version=\"1.0\"?>"
				+ "<nrf:NRFTransaction version=\"07.01.0001\" "
			    + "RequestMethodName=\"raveGetIsDutiable\" RequestMethodResponseName=\"raveGetIsDutiableResponse\" "
			    + "transactionID=\"15523280765362\" xmlns:nrf=\"http://ups.com/nrfServerInterface\">"
			    + "<nrf:Request><nrf:raveGetIsDutiable origCountry=\"CA\" origPostalCode=\"\" origCity=\"\" destCountry=\"DE\" "
			    + "destPostalCode=\"\" destCity=\"\"/></nrf:Request></nrf:NRFTransaction>";
	}
	
	public static String getCustomer() {
		
		System.out.println("getCustomer getting called");
		
		return "<?xml version=\"1.0\"?>"
				+ "<nrf:NRFTransaction version=\"07.01.0001\" RequestMethodName=\"raveGetCurrencyInfo\" "
				+ "RequestMethodResponseName=\"raveGetCurrencyInfoResponse\" transactionID=\"15523212749834\" "
				+ "xmlns:nrf=\"http://ups.com/nrfServerInterface\"><nrf:Request><nrf:raveGetCurrencyInfo "
				+ "originCode=\"US\" destCode=\"US\"/></nrf:Request></nrf:NRFTransaction>";
	}
	
	public static String getOrder() {
		
		System.out.println("getOrder getting called");
		
		return "<?xml version=\"1.0\"?>"
				+ "<nrf:NRFTransaction version=\"07.01.0001\" RequestMethodName=\"raveGetCurrencyInfo\""
				+ " RequestMethodResponseName=\"raveGetCurrencyInfoResponse\" transactionID=\"15523279069925\" "
				+ "xmlns:nrf=\"http://ups.com/nrfServerInterface\"><nrf:Request><nrf:raveGetCurrencyInfo "
				+ "originCode=\"CA\" destCode=\"CA\"/></nrf:Request></nrf:NRFTransaction>";
	}
	
	public static String getLetter() {
		
		System.out.println("getLetter getting called");
		
		return "getLetter " + 
				"<requestMade>" + 
				"   <requestDetails uri=\"POST getLetter TCPDEMO/1.1\" purpose=\"TestTCPProtocol\" content-type=\"XML\" />" + 
				"</requestMade>;";
	}

	public static void readBufferedReader(BufferedReader br) throws IOException {
		String readtext=null;
		int i=0;
		while((readtext=br.readLine())!=null) {
			System.out.println("Respone=" + readtext);
		
			if(readtext.contains("</nrf:Response>"))
			{
				//System.out.println("------- read complete-------");
				break;
			}
		}
				
	}
	
}
